// Copyright 2015-2018 Elviss Strazdins. All rights reserved.

#pragma once

#include <future>
#include "input/InputDevice.hpp"
#include "math/Vector2.hpp"

namespace ouzel
{
    namespace input
    {
        class TouchpadDevice: public InputDevice
        {
        public:
            TouchpadDevice(InputSystem& initInputSystem, uint32_t initId):
                InputDevice(initInputSystem, initId, Controller::Type::TOUCHPAD)
            {
            }

            std::future<bool> handleTouchBegin(uint64_t touchId, const Vector2& position, float force = 1.0F);
            std::future<bool> handleTouchEnd(uint64_t touchId, const Vector2& position, float force = 1.0F);
            std::future<bool> handleTouchMove(uint64_t touchId, const Vector2& position, float force = 1.0F);
            std::future<bool> handleTouchCancel(uint64_t touchId, const Vector2& position, float force = 1.0F);
        };
    } // namespace input
} // namespace ouzel
